#!/bin/bash

######################################################
#
#	checkbackup2remove.sh
#
#	Parameter:
#			<Pfad des Basisverzeichnisses>
#			<dsm.opt Dateien>
#
#
#
#
#
#
#
######################################################

function checkgoobibackup
{
	DSMC_BINPATH="/usr/tivoli/tsm/client/ba/bin"
	if [ ! -e ${DSMC_BINPATH}/dsmc ]; then
		echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE Archiv-Client dsmc in $DSMC_BINPATH nicht gefunden." >> $LOGFILE
		exit 1
	fi
	tmp_filelist="/tmp/checkbackup.txt"
	goobi_id=${1#*_};
	goobi_id=${goobi_id%%_*};
	goobi_backupsearchfile1="/san/work/goobi/daten/${goobi_id}/images/scans_tif/00000001.tif"
	goobi_backupsearchfile2="/san/work/goobi/daten/partitions/"$[$goobi_id / 10000]"/${goobi_id}/images/scans_tif/00000001.tif"
	goobi_backupsearchfile3="/san/work/partition/"$[$goobi_id / 10000]"/${goobi_id}/images/scans_tif/00000001.tif"
	printf "${goobi_backupsearchfile1}\n${goobi_backupsearchfile2}\n${goobi_backupsearchfile3}\n" > $tmp_filelist

	dsmc_cmd="$DSMC_BINPATH/dsmc query backup -optfile=${GOOBI_TSM_OPTFILE} -inactive -filelist=${tmp_filelist}"
# Pruefen ob String "00000001.tif" am Ende einer Zeile steht -> Zeichen, dass im Backup vorhanden und Return=0, sonst 1
	dsmc_string=`$dsmc_cmd|grep "00000001.tif$"`	
	return $?
}

function checkarchive
{
	DSMC_BINPATH="/opt/tivoli/tsm/client/ba/bin"
	
	service=$1
	job_id=$2
	if [ ! -e ${DSMC_BINPATH}/dsmc ]; then
		echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE Archiv-Client dsmc in $DSMC_BINPATH nicht gefunden." >> $LOGFILE
		return 1
	fi	
	dsmc_cmd="$DSMC_BINPATH/dsmc query archive /$service/${job_id}.tar -optfile=/opt/tivoli/tsm/client/ba/bin/dsm-archive.opt"
	dsmc_string=`$dsmc_cmd`
	return $?
}




LOGFILE="/var/log/jobs/archive/$(hostname)_archive_processing_`date +%Y%m%d`.log"

LOCKFILE="/var/locks/docs2remove.lock"

#dsm.opt vom goobi-Backup
GOOBI_TSM_OPTFILE="/usr/tivoli/tsm/client/ba/bin/dsm-fast.opt"

if [ $# -lt 1 ]; then
	echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE Zu wenig Parameter uebergeben." >> $LOGFILE
	exit 1
fi

if [ -e $LOCKFILE ]; then
        echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE Skript laeuft scheinbar schon, lockfile '$LOCKFILE' existiert." >> $LOGFILE
        exit 1
else
        echo $$ > $LOCKFILE
fi


# Pfad zu dsmc (Archiv Client)
DSMC_BINPATH="/opt/tivoli/tsm/client/ba/bin"
if [ ! -e ${DSMC_BINPATH}/dsmc ]; then
	echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE Archiv-Client dsmc in $DSMC_BINPATH nicht gefunden." >> $LOGFILE
	exit 1
fi

# Parameter uebergeben
basefolder=$1
#tsm_optfile=$2


i=0
echo "ls $basefolder/docs2remove"
for job_id in `ls $basefolder/docs2remove`
do
	service=${job_id%%_*}       # pattern matching, alles vor dem ersten _ wird zurueck gegeben
#	if [ "$service" == "goobi" ]; then
#		checkgoobibackup $job_id
#		if [ $? != 0 ]; then
#			echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh Kein Backup von $job_id vorhanden." >> $LOGFILE
#			continue
#		fi
#	fi

	checkarchive $service $job_id
	if [ $? != 0 ]; then
		echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh Kein Archiv von $job_id vorhanden." >> $LOGFILE
		continue
	fi
	if [ -n $job_id ]; then
		rm -fr $basefolder/$job_id | awk '{print "[FE] '"\`date +%Y%m%d\ %T\`"' " $0}' 2>&1 >> $LOGFILE
		if [ $? == 0 ]; then
			echo "[OK] `date +%Y%m%d\ %T` checkbackup2remove.sh Verzeichnis ${basefolder}/${job_id} erfolgreich geloescht." >> $LOGFILE
			rm -f $basefolder/docs2remove/$job_id | awk '{print "[FE] '"\`date +%Y%m%d\ %T\`"' " $0}' 2>&1 >> $LOGFILE
		else
			echo "[FE] `date +%Y%m%d\ %T` checkbackup2remove.sh Verzeichnis ${basefolder}/${job_id} nicht geloescht FehlerNr: $?." >> $LOGFILE
		fi
	fi
done


echo "[OK] `date +%Y%m%d\ %T` checkbackup2remove.sh ENDE " >> $LOGFILE
`rm -f $LOCKFILE 2>&1 >> $LOGFILE`
exit 0

